Coin Change - Dynamic Programming Bottom Up - Leetcode 322

  Рет қаралды 517,646

NeetCode

NeetCode

Күн бұрын

Пікірлер: 299
@NeetCode
@NeetCode 3 жыл бұрын
🚀 neetcode.io/ - A better way to prepare for Coding Interviews
@aaditkamat4995
@aaditkamat4995 2 жыл бұрын
We can also initialize the array with amount instead of amount + 1 right, because the maximum number of coins used will be in the case where each coin you use is a 1 coin?
@jagdish-main
@jagdish-main 2 жыл бұрын
@@aaditkamat4995 what if you have to form amount 10 and you have only 1 unit coin , than total number of coins will be 10 which is equal to the amount
@MP-ny3ep
@MP-ny3ep Жыл бұрын
Love how you went from the greedy approach to the brute force dfs approach to the optimal dp approach. It helped me understand this problem better. Thank you !
@MIDNightPT4
@MIDNightPT4 2 жыл бұрын
Dynamic Programming is so confusing!!!!!!
@ehm-wg8pd
@ehm-wg8pd 8 ай бұрын
yes its hard for me at begining, you should try with cases that has shaloe level of recursive and learn from there
@ivandrofly
@ivandrofly 6 ай бұрын
YET beautiful :D
@adithyagowda4642
@adithyagowda4642 3 жыл бұрын
The way you explained DFS approach and converted it into a DP solution was just freaking amazing!!! It's exactly what I was looking for. I now feel confident in converting my DFS solutions into DP solution. Thank you very much!
@perelium-x
@perelium-x Ай бұрын
For those having a hard time with dp just some advice 1. Decision Trees 2. Recursion 3. Optimal Substructure and Overlapping Subproblem then just Memoize you have urself dp tc
@richard12345789
@richard12345789 3 жыл бұрын
actually neet's explanation to compare dfs,greedy and then using dp is soo rad and lowkey!! man u are awesome. give me a few more days i am gonna start donating for ur coffee's each week
@NeetCode
@NeetCode 3 жыл бұрын
Thanks appreciate it a lot 😊
@Nahwka
@Nahwka 2 ай бұрын
@richard12345789 Have you started donating. 😂?
@souravchakraborty700
@souravchakraborty700 2 жыл бұрын
Anyone curious about top to bottom recursion(backtracking with memoization) : def coinChange(self, coins: List[int], amount: int): memo = {} def dfs(amount): if amount == 0: return 0 if amount
@vyshakr3058
@vyshakr3058 2 жыл бұрын
thanks i was actually searching for this
@satyajeetkumarjha1482
@satyajeetkumarjha1482 2 жыл бұрын
Your dp code is similar to what most of us will code but your code is more readable. Highly appreciable .
@DoJoStan
@DoJoStan 3 жыл бұрын
Excellent explanation, I was trying to wrap my head around the bottom up approach solution described on leetcode and you illustrated it perfectly.
@lcgrind
@lcgrind 4 ай бұрын
same! I was lost at what dp[i - coin[j]] meant, and it finally clicked when I watched this video at the @13:30s mark. Ty!
@cody_code
@cody_code 2 жыл бұрын
Wow, I was so stumped on this concept until I found this video. Thanks for going the extra mile with the explanation!
@theooh1337
@theooh1337 3 жыл бұрын
love your videos mate whenever I am stuck I go straight to your channel instead of 'Solution' section. Keep it coming!
@pomegranate8593
@pomegranate8593 2 жыл бұрын
excellent, I love how patient and carefully u explain instead of rushing stuff and skipping steps
@wilsonwang8641
@wilsonwang8641 2 жыл бұрын
The part at 12:20 really helps me to clarify the problem. Thanks bro Neetcode, you produce really meaningful content.
@inquisitorshampoo1043
@inquisitorshampoo1043 3 жыл бұрын
Have my amazon interview in 10 minutes. Your videos have been incredibly helpful while studying!
@chuongtruong7090
@chuongtruong7090 3 жыл бұрын
How was your interview ?
@inquisitorshampoo1043
@inquisitorshampoo1043 3 жыл бұрын
@@chuongtruong7090 good! ended up getting an offer
@chuongtruong7090
@chuongtruong7090 3 жыл бұрын
@@inquisitorshampoo1043 Wow, congrats !!!!
@EDROCKSWOO
@EDROCKSWOO 3 жыл бұрын
@@inquisitorshampoo1043 goddamn so lucky. I got rejected by google, a week ago. I cry.
@mastermind5421
@mastermind5421 3 жыл бұрын
@@EDROCKSWOO what questions did they ask you?
@halahmilksheikh
@halahmilksheikh 2 жыл бұрын
For anyone curious, here's what the top down DP with memoization looks like. It's very slow. If you remove the memoization, you get a time limit exceeded but it still "works" var coinChange = function(coins, amount) { let memo = [] // with memoization let ret = dfs(amount) if (ret == Infinity) ret = -1 return ret function dfs(target) { // returns min from all paths if (target < 0) { return Infinity } if (target == 0) { return 0 } if (memo[target] != null) { return memo[target] } memo[target] = Infinity for (let coin of coins) { memo[target] = Math.min(memo[target], 1 + dfs(target - coin)) } return memo[target] } };
@mastermax7777
@mastermax7777 Жыл бұрын
why is it slow? I wrote it in python and it was just as fast as the dp solution he gave us...
@PippyPappyPatterson
@PippyPappyPatterson Жыл бұрын
@@mastermax7777 Agreed, shouldn't it be the same complexity? It only checks the number of paths to `0` once for each `range(amount)`.
@ahmadbasyouni9173
@ahmadbasyouni9173 4 ай бұрын
your channel saves me so much time than trying to read the weird wording of the editorial on LC appreciate you man!
@rachelwilliams8569
@rachelwilliams8569 2 ай бұрын
For the range you are looping over in line 6, you don't need to go from 1..amount + 1. You only need to loop from 1 to the amount since you already covered 0 before the loop.
@emachine003
@emachine003 4 ай бұрын
Thanks for the help... I figured out top-down memoization on my own, so fortunately most of my work carried over to the bottom-up approach.
@woostanley6290
@woostanley6290 6 ай бұрын
This is such a hard question and I am really thankful that you are here to help to explain how to proceed with dp problems...
@yipeng6239
@yipeng6239 2 жыл бұрын
You are more qualified than most university instructors on introducing DSA topics, no joke
@TheSRONIX
@TheSRONIX 2 жыл бұрын
Thank you so much for the thought process of how to get to the dynamic programming solution!
@KevinN44
@KevinN44 3 жыл бұрын
Awesome explanation! I was stuck with the top down approach and how to convert it to the DP solution, and this made it all click. Thanks!
@andrewwong8483
@andrewwong8483 10 ай бұрын
Really good explanation of the 1+dp[a] and what the 1 means in this case- because we’re using one coin as we’re iterating through the coins
@rjtwo5434
@rjtwo5434 2 жыл бұрын
I was so close here but this helped to sort it out for me. Hands down the best explanations on this stuff. Thank you so much for this!
@linli7049
@linli7049 3 жыл бұрын
When I search for a solution for a problem on leetcode, I will watch your video first. Excellent explanation!
@juliahuanlingtong6757
@juliahuanlingtong6757 3 жыл бұрын
Good explantion starting from recursion tree. However, during the transformation from recursion to bottom up dp, I really tried to search the answer to my 2 confusion, yet failed to find it. 1. How did dp resolve the problem of dupliactes, eg, 1,5,1 and 1,1,5 are essentially the same and if we do through recursion, we have to add logic ro avoid that, but why dp arrays don't have to? 2. How does it evolevs into a knapsack (take or not take ) problem? In another word, why dp[a]=min(dp[a], dp[a-c])? Looking forward to your reply to rsolve my huge confusions. Thanks!
@sumitevs
@sumitevs 2 жыл бұрын
i have the same doubt. why dp[a]=min(dp[a], dp[a-c])?
@JasonKim1
@JasonKim1 2 жыл бұрын
Duplicates don't matter here because what is cached is the minimum coins used. With your example, DP[7] is 3 whichever coin options are used. If the question has asked, return all the possible combinations of coins that make up the minimum number of coins uses, and the question explicitly asks you to dedupe cases like 1,1,5 and 1,5,1, then you have to care about dupes.
@RohithMusic
@RohithMusic Жыл бұрын
@@sumitevs I think we can think of it in a different way. dp[a] = 1+min(dp[a-c1],dp[a-c2], ...dp[a-ci]) where 1 to i is the different denominations of coins given. It looks confusing in code because he is doing a loop over ci and storing the min in dp[a] itself after every iteration.
@keystarr
@keystarr 4 ай бұрын
thank you, man, couldn't solve on my own and didn't understand both the Editorial and one of the top submissions. Only your explanation did it for me!
@madixit75
@madixit75 2 жыл бұрын
Impressed, I was going nuts with leet code premium explanation. I owe you👌
@airman122469
@airman122469 4 ай бұрын
There’s also a simple recursive way of doing this problem. Take the amount of change you’re looking for, find the largest denomination that does not go over the amount of change being requested, subtract that denomination from the amount requested, and call the same function with the new value. To account for values that are higher than the largest denomination, simply take the change amount value and subtract the integer division value that results from the change requested divided by the largest denomination, and again, call the function recursively.
@RobertPodosek
@RobertPodosek 9 ай бұрын
This is brilliant. Really helped me understand dynamic programming. Thanks!
@jackchan6266
@jackchan6266 Жыл бұрын
i commented on the code for my learning hopefully this is helpful class Solution(object): def coinChange(self, coins, amount): """ :type coins: List[int] :type amount: int :rtype: int """ dp = [amount + 1] * (amount + 1) # 0 to amount so amount + 1 in total dp[0] = 0 # base case, amount 0 takes 0 coins print(dp) #bottom up order for a in range(1, amount + 1): # to get to each number in 1 to the amount + 1 for c in coins: # go through every coin if a - c >= 0: # remainder dp[a] = min(dp[a], 1 + dp[a - c]) # go through every possible solution # coin = 4, a = 7, dp[7] = 1 + dp[7-4] = 1 + dp[3] # dp stores the number of coins needed to get to that number, therefore we get 1 for in 1 + dp[a - c] for an additional coin needed print(dp) return dp[amount] if dp[amount] != amount + 1 else -1 # dp[amount] != amount + 1 is the default value
@wlcheng
@wlcheng 2 жыл бұрын
Brilliant explanation! I was able to come up with the code by myself after understanding your solution. And the implementation is quite similar to yours. Guess I followed your coding style pretty well. 😆
@n-julkushwaha2827
@n-julkushwaha2827 Жыл бұрын
one of the best solutions and explanation. Even though i knew the solution but still got stunned by your approach........
@evyats9127
@evyats9127 Жыл бұрын
Nice and short functional programming style solution: dp = [0] for i in range(1, amount+1): options = [dp[i-x] for x in coins if i >= x and dp[i-x] != -1] dp.append(-1 if not options else 1+min(options)) return dp[amount]
@kennyelkhart
@kennyelkhart Жыл бұрын
What is ‘functional’ about this? Also, why constantly resize an array if you know its size (amount+1) ahead to time?
@utberoxsobad
@utberoxsobad 2 жыл бұрын
I got this question in an Amazon technical interview. I wish I saw this video beforehand
@George-nx8zu
@George-nx8zu 2 жыл бұрын
Dynamic Programming is always so fuzzy to me. Thank you for explaining!
@jagdish-main
@jagdish-main 2 жыл бұрын
I watched this problem in so many videos but all of them was forcing me to remember things and making this problem complex but you made it so intuitive like it's damm easy, thanks for helping :)
@SaurabhGupta-ei2hl
@SaurabhGupta-ei2hl 3 жыл бұрын
Best Explanation on Dynamic Programming in a Scientific Approach!! 🙌🏻
@germanou
@germanou 7 ай бұрын
Dude, your explanation ability is over the top. Amazing!
@nikhilaradhya4088
@nikhilaradhya4088 4 ай бұрын
Good. You can start at min coin value in the outer for loo. It takes O(len(coins)) extra time to find the min. Helps in cases where amount is too large and number of coins of small.
@himeshsylesh
@himeshsylesh 2 жыл бұрын
You had made the best explanation found on youtube for this problem, with 3 different approaches. Thanks, buddy.
@CarlosNexans
@CarlosNexans Ай бұрын
BFS with a Bitmap is also accepted, with the same complexity. Almost the same memory footprint but DP is a lot faster. Sequential memory access is very efficient.
@qualityhumour1510
@qualityhumour1510 2 жыл бұрын
Your explanations skills are really amazing! Definitely very helpful! 🤓
@mrpotato2027
@mrpotato2027 Жыл бұрын
Extremely well explained. Thank you so much!
@akhilraj6891
@akhilraj6891 Жыл бұрын
We can make the code work in constant space complexity by just storing the answer for last five amounts when calculate the current amount.
@Techgether
@Techgether 4 ай бұрын
Love the clear and concise explanation!
@yunusemreozvarlik2906
@yunusemreozvarlik2906 2 ай бұрын
Clean and concise explanation. Thanks!
@georgpohl2665
@georgpohl2665 2 жыл бұрын
Very well explained. Thank you i finally understood this problem. Keep at it!
@Babe_Chinwendum
@Babe_Chinwendum 2 жыл бұрын
Mann, my first approach was greedy. Thanks for explaining why it did not work out.
@koubbe
@koubbe 2 жыл бұрын
I know this problem is best solved by using Dynamic Programming, but I want to focus on the Brute Force solution: I can say it is Divide and Conquer: We are dividing the problem into smaller sub-problems, solving individually and using those individual results to construct the result for the original problem. I can also say it is Backtracking: we are enumerating all combinations of coin frequencies which satisfy the constraints. I know both are implemented via Recursion, but I would like to know which paradigm the Brute Force solution belongs to: Divide and Conquer or Backtracking.
@spoorthi5230
@spoorthi5230 3 жыл бұрын
Thank you! Definitely better explanation than the leetcode's explanation!
@NeetCode
@NeetCode 3 жыл бұрын
Glad it was helpful!
@The6thProgrammer
@The6thProgrammer Жыл бұрын
If you are struggling to understand why we updated dp[i] when (i - coins[j] >= 0) the key insight is that dp[i] only gets updated if there is a solution that leads to zero (even when this condition evaluates to true). That is, there are cases where (i - coins[j] >= 0) but dp[i] remains "amount + 1". For instance if we have amount = 11 and coins = [2, 4, 6], when we get to i = 3, we find that 3 - 2 >= 0. However, min(dp[3], 1 + dp[3 - 2]) causes dp[3] to remain "amount + 1" as there is no valid solution leading to zero that we captured at dp[1] (that is, dp[1] itself still equals "amount + 1").
@psychogalvanometer8945
@psychogalvanometer8945 2 жыл бұрын
Finally found a solution that I can understand. Thank you Sir!
@kwaminaessuahmensah8920
@kwaminaessuahmensah8920 3 жыл бұрын
Bro, your explanations are so good. Keep up the amazing work!
@alessandrocamillo4939
@alessandrocamillo4939 3 жыл бұрын
Great video, great explanation. It starts from the brute force approach to build up he required intuition to eventually realize we can use a DP based solution. Thank you very much. One thing I wish to comment is that I am now curious to see a DP top-down recursive solution based on memoization. ;)
@namelesslamp12
@namelesslamp12 3 жыл бұрын
Me too since i am new to dp memoization sometimes it's not clear to me :)
@GauravDhiman
@GauravDhiman 2 жыл бұрын
Here is the python DP top-down recursive solution with memoization. It took me some time to come up with it. class Solution: def __init__(self): self.memo = {} self.coins = None def coinChange(self, coins: List[int], amount: int) -> int: if self.memo.get(amount) != None: return self.memo[amount] if amount == 0: return 0 if self.coins == None: self.coins = sorted(coins) minc = float("inf") for c in self.coins: if amount < c: break res = self.coinChange(coins=None, amount=amount-c) if res == -1: continue minc = min(res + 1, minc) res = -1 if minc == float('inf') else minc self.memo[amount] = res return res
@edenrosales8214
@edenrosales8214 2 жыл бұрын
Are the dynamic programming and dfs solutions different in terms of space or time complexity?
@georgechen1124
@georgechen1124 7 ай бұрын
Well explained, bro! Impressive DP solution!
@hudsonriverrunner
@hudsonriverrunner 3 жыл бұрын
for those who wanna know the optimal, check bidirectional BFS with DP, it beats 99.6%
@observer698
@observer698 2 жыл бұрын
? how?
@srinadhp
@srinadhp 3 жыл бұрын
Thanks again! Your explanation helped a great deal in understanding these complex problems.
@惠雨-g8q
@惠雨-g8q Жыл бұрын
Really clear pronunciation! Also the explanations!
@ashleywilkonson386
@ashleywilkonson386 3 жыл бұрын
Could you do the DP solution for Partition to K Equal Sum Subsets? There are literally no English explanations for it, only the backtracking approach.
@danielsun716
@danielsun716 2 жыл бұрын
couple questions: 1. dp[a] = min(dp[a], 1 + dp[a - c]), why should compare itself with 1 + dp[a-c]? is it possible dp[a] it self less than 1 + dp[a- c]? 2. why the condition is if dp[amount] != amount + 1:? if coins = [2], amount = 3, how should it explain under this situation? I am so confused.
@CasualyinAir
@CasualyinAir 3 жыл бұрын
Thank you. Your explanation is really clear.
@ramonjales9941
@ramonjales9941 2 жыл бұрын
i'm from Brazil. And you gained more one subscriber.Because your explanation is very good and you talk so cleary that i can undestand you. And this is so good for me that i'm learning english.
@enisarik6002
@enisarik6002 2 жыл бұрын
First understand DFS very well, and then try to understand bottom-up DP concept. Coding is trivial, but understanding the whole solution is really hard.
@hamzabendi9751
@hamzabendi9751 3 жыл бұрын
I don't think this solution would work in all cases. Let's say you can only use the coins (2, 5, 10) to return a value of 2, at the first iteration and when trying to calculate dp[1] you're gonna find out that no coin is smaller that 1 so the condition "a - c >= 0" will not be met, and so dp[1] will stay equal to amount+1 (and this is gonna screw what comes next). So if you try to know the number of coins needed to return a value of 2 (it should be 1 cause we have 2 in our list of coins), this algorithm will return -1 because you will have dp[2] = amount+1. I'm not sure if i explained my process of thoughts right, if you think i'm wrong i'd be happy to learn.
@mk-19memelauncher65
@mk-19memelauncher65 2 жыл бұрын
Dp2 will be min of maxInt and 1+ dp[2-2] which hits the basecase of 0 and returns 1 correctly
@gn03398604
@gn03398604 2 жыл бұрын
It's a pretty clear solution. really helps me a lot! appreciate!!!
@AfterThisShutUp
@AfterThisShutUp 4 ай бұрын
This can also be solved using breadth-first search since we are trying to find the shortest path from amount to 0.
@johnhammer8668
@johnhammer8668 2 жыл бұрын
Thankyou very much. The DFS part is just amazing. It was visually intuitive.
@nikhilgoyal007
@nikhilgoyal007 10 ай бұрын
self notes: Not greedy - since 5 + 1 + 1 will not work; backtracking - yea but overlapping subproblems so can use DP; Memoization works ; now think in reverse and do bottoms up .
@edreesomer9851
@edreesomer9851 10 ай бұрын
What is the difference between back tracking and dfs? I know dft in graph but how is it used here?
@Nerdimo
@Nerdimo 2 жыл бұрын
Definitely a confusing one, I hope sometime in the future I understand it better. Thanks for the tip
@bonle3771
@bonle3771 Жыл бұрын
arent both DP? first one seems to be easier to think of. One of the other way I was doin. is to traverse the sorted coins from the
@bikcrum
@bikcrum 2 жыл бұрын
I was able to code myself after looking at your video. Great explanation.
@lucasshi1091
@lucasshi1091 Жыл бұрын
Does time complexity differ if we choose top-down dynamic programming? I think top-down is better because we don't have to compute every number in the range of amount. Am I right?
@superheroherohero
@superheroherohero 2 жыл бұрын
Thank you, very very clear, your videos have very high quality.
@ahmeeeeeeeeeeeed
@ahmeeeeeeeeeeeed 3 жыл бұрын
Great video, deserves at least one million views in my opinion.
@NeetCode
@NeetCode 3 жыл бұрын
Thanks, i appreciate it
@Asmrnerd10
@Asmrnerd10 Жыл бұрын
The correct solution on leetcode has ur OUTER loop as its INNER LOOP and your INNER loop as its OUTER loop. Why is it switched around? For example the solution on leetcode says this: Bottom up DP class Solution: def coinChange(self, coins: List[int], amount: int) -> int: dp=[math.inf] * (amount+1) dp[0]=0 for coin in coins: for i in range(coin, amount+1): if i-coin>=0: dp[i]=min(dp[i], dp[i-coin]+1) return -1 if dp[-1]==math.inf else dp[-1]
@kennyelkhart
@kennyelkhart Жыл бұрын
It’s just enumerating the coins first. The time complexity is the same and so is the result, as the correct minimum is still discovered.
@symbol767
@symbol767 2 жыл бұрын
Sick, I tried this for the first time on my own and used BFS to find the "shortest path". Sadly I knew I needed to optimize it with caching but couldn't figure out the right way to implement it. When I saw I only needed 3 extra lines to finish my solution I felt hella dumb. But this is a really good problem.
@LumartCh
@LumartCh 5 ай бұрын
Great explanation, regardless I'm still trying to understand the whole concept 😅
@siddharthsharma3679
@siddharthsharma3679 3 жыл бұрын
Dude !!! I don't usually drop comments but this was amazing ! Crisp explanation, thank you soo much.
@muhammetguduk2020
@muhammetguduk2020 2 жыл бұрын
Wish I saw this question earlier. I'd have nailed the Intel's coding interview ... Only one that I couldn't solve was this one..
@Why_I_am_a_theist
@Why_I_am_a_theist Жыл бұрын
One more thing, if you initialize dp[0] = 1 then you don't need to do 1+ dp[a-c] and this is okay because what is the no of ways to make sum 0 out of n no of coins , the answer is 1 i.e don't consider any coin
@kasiruyamagata7716
@kasiruyamagata7716 2 жыл бұрын
U r just awesome U make complex solutions easy
@sekirandahamza1260
@sekirandahamza1260 Жыл бұрын
Very well explained. I'm a newbie to dp in general, Do people solve these problems off head in interviews? or they just cram the solutions and go for it, because I'm having trouble wrapping my head around these problems.
@Ryan-sd6os
@Ryan-sd6os 2 жыл бұрын
you dont really explain the dp formula from dp[2] to the end
@samrat_malisetti
@samrat_malisetti 7 ай бұрын
It's good to have the Pseudo code of brute force solution using recursion. Because I was confused about the base cases.
@kez007007
@kez007007 8 ай бұрын
You know without programming this is a question for 5 years old...which coins add up to 7.
@DanielVazquez
@DanielVazquez 3 жыл бұрын
Greedy does work if we remove the biggest coin at every full iteration and keep checking for the minimum amount of change. This, however, is pretty inefficient.
@RanjuRao
@RanjuRao 3 жыл бұрын
crystal clear illustration :) awesome ! Thanks for the video
@kobebyrant9483
@kobebyrant9483 3 жыл бұрын
Great explanation. Crystal clear!
@stockholmsyndromeself-trea7517
@stockholmsyndromeself-trea7517 2 жыл бұрын
Yo... Kobe...
@ThEHaCkeR1529
@ThEHaCkeR1529 2 жыл бұрын
Why does it remain amount+1 if it is impossible to create the combination?
@premrr8330
@premrr8330 3 жыл бұрын
Next level explanation! Instantly subscribed! Thank you
@pfiter6062
@pfiter6062 Жыл бұрын
if we were given an input like this coins = [50], amount = 100 would the dfs solution faster than dp solution?
@m____s
@m____s 6 ай бұрын
that was my doubt too
@Call-me-Avi
@Call-me-Avi 2 жыл бұрын
Pretty neat explanation man. Thank you
@3rd_iimpact
@3rd_iimpact Жыл бұрын
At 17:19, why are we adding a 1? He explains but I'm still confused.
@hassanhassan-e7w
@hassanhassan-e7w Жыл бұрын
great explanation. thank you very much.
@asianhero2.096
@asianhero2.096 Жыл бұрын
Can someone explain why we set every value to amount + 1 and in what way it acts as a max value?
@adityaverma3247
@adityaverma3247 2 ай бұрын
What software you use to explain using figures, diagram ? Please elaborate, because its needed for everyone to explain way you do in interviews.
@Aditya1057
@Aditya1057 3 жыл бұрын
A very nice explanation, thank you.
@andreslikesramen
@andreslikesramen 3 жыл бұрын
Great Explanation and Visuals
Mastering Dynamic Programming - How to solve any interview problem (Part 1)
19:41
Perfect Pitch Challenge? Easy! 🎤😎| Free Fire Official
00:13
Garena Free Fire Global
Рет қаралды 100 МЛН
How To Choose Mac N Cheese Date Night.. 🧀
00:58
Jojo Sim
Рет қаралды 88 МЛН
Climbing Stairs - Dynamic Programming - Leetcode 70 - Python
18:08
How to Solve ANY LeetCode Problem (Step-by-Step)
12:37
Codebagel
Рет қаралды 300 М.
The Change Making Problem - Fewest Coins To Make Change Dynamic Programming
23:12
Coin Change - Leetcode 322 - Dynamic Programming (Python)
15:27
DP 20. Minimum Coins | DP on Subsequences | Infinite Supplies Pattern
34:15
5 Simple Steps for Solving Dynamic Programming Problems
21:27
Reducible
Рет қаралды 1,1 МЛН
LeetCode was HARD until I Learned these 15 Patterns
13:00
Ashish Pratap Singh
Рет қаралды 577 М.
Perfect Pitch Challenge? Easy! 🎤😎| Free Fire Official
00:13
Garena Free Fire Global
Рет қаралды 100 МЛН